<?php

namespace Drupal\form_display_field_alter_test\Plugin\Field\FieldWidget;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\WidgetBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Provides a field widget plugin for this module's tests.
 *
 * Copyright (C) 2025  Library Solutions, LLC (et al.).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * @FieldWidget(
 *   id = "form_display_field_alter_test",
 *   label = @Translation("Form display field alter test"),
 *   field_types = {
 *     "string",
 *   },
 * )
 */
class FormDisplayFieldAlterTestWidget extends WidgetBase {

  /**
   * {@inheritdoc}
   */
  public function form(FieldItemListInterface $items, array &$form, FormStateInterface $form_state, $get_delta = NULL) {
    $element = parent::form($items, $form, $form_state, $get_delta);

    $element['#definition'] = $this->fieldDefinition;
    $element['#items_definition'] = $items->getFieldDefinition();

    return $element;
  }

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
    $element['value'] = $element;

    $element['value']['#type'] = 'textfield';
    $element['value']['#default_value'] = $items[$delta]->value ?? NULL;

    return $element;
  }

}
